"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var commander = require("commander");
var _1 = require(".");
var debug_1 = require("debug");
var log = debug_1.default("json-property-filter:cli");
function readFile(file) {
    return new Promise(function (resolve, reject) {
        return fs.readFile(file, function (error, data) { return (error ? reject(error) : resolve(data)); });
    });
}
function writeFileAsync(file, data) {
    return new Promise(function (resolve, reject) { return fs.writeFile(file, data, function (error) { return (error ? reject(error) : resolve()); }); });
}
function handle(file, options) {
    return __awaiter(this, void 0, void 0, function () {
        var buffer, content, jsonContent, result, data;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    log("Read file: %s", file);
                    return [4, readFile(file)];
                case 1:
                    buffer = _a.sent();
                    content = buffer.toString(options.encoding);
                    jsonContent = JSON.parse(content);
                    log("Apply filters: %o", options.filters);
                    result = _1.apply(jsonContent, options.filters);
                    data = options.pretty ? JSON.stringify(result, void 0, +options.prettySpace) : JSON.stringify(result);
                    if (!options.out) return [3, 3];
                    log("Write file: %s", file);
                    return [4, writeFileAsync(options.out, data)];
                case 2:
                    _a.sent();
                    return [3, 4];
                case 3:
                    process.stdout.write(data);
                    _a.label = 4;
                case 4: return [2];
            }
        });
    });
}
commander
    .version("2.0.0")
    .description("Filter a JSON object by including and excluding properties.")
    .requiredOption("--in <file>", "File to filter.")
    .requiredOption("-f, --filters <filters...>", "Add include and exclude filters.")
    .option("--out <file>", "Specifies the output file.")
    .option("-p, --pretty", "Display results in an easy-to-read format.", false)
    .option("--pretty-space <number>", "Specifies the space.", "4")
    .option("--encoding", "Specifies encodage.", "utf8")
    .option("--debug", "Enable debug mode.", false)
    .parse(process.argv);
if (commander.debug) {
    debug_1.default.enable("json-property-filter:*");
}
handle(commander.in, {
    encoding: commander.encoding,
    filters: commander.filters,
    out: commander.out,
    pretty: commander.pretty,
    prettySpace: commander.prettySpace,
});
